%------------------------------------------------------------------------------
\section{Messages}
%------------------------------------------------------------------------------

\paragraph{Usage}

\begin{verbatim}
ghci -Wall -package rh Message.lhs
\end{verbatim}

%if False
%- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
\subsection{Module header}
%- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

%endif

> module Message (module Message, module PrettierNG)
> where
> import PrettierNG hiding (int, integer, string)

%-------------------------------------------------------------------------------
\section{Type definitions}
%-------------------------------------------------------------------------------

> data Message  =  Title     Doc
>               |  Subtitle  Doc
>               |  Debug     Doc
>               |  Warning   Doc
>               |  Error     Doc
>                  deriving (Show)

> instance Pretty Message where
>   prettyPrec _ (Title     d)  =  title ">>>"  d
>   prettyPrec _ (Subtitle  d)  =  title ">> "  d
>   prettyPrec _ (Debug     d)  =  d
>   prettyPrec _ (Warning   d)  =  title "***"  d
>   prettyPrec _ (Error     d)  =  title "***"  d
>
>   prettyList ms  =  intersperse nl (map pretty ms)
>
> --title s d  =  block (length s + 1) (text s <> sp <> d)
> title s d  =  block 4 (text (s ++ " ") <> d)
>
> data Pass aT  =  Fail [Message]
>               |  Succeed aT  [Message]
>                  deriving (Show)